import sys, pygame, random, time, creature, color,vector

class Life:
  "Simulates a flock of creatures"
  
  def __init__(self):
    self.width, self.height = 800, 600
    self.creature_size = 8 
    population_size=50
    self.background = color.Color(20,20,255) 
    self.population = []
    
    
    for i in range(0,population_size):
      self.population.append(creature.Creature()) 
      
    for critter in self.population:
      for other_critter in self.population:
        if(critter!=other_critter): critter.add_neighbour(other_critter)
    
    pygame.init()
    self.screen = pygame.display.set_mode((self.width, self.height),pygame.HWSURFACE|pygame.DOUBLEBUF|pygame.RESIZABLE )
    self.screen.fill(self.background.tupel())
    pygame.display.flip()

  def draw(self):
     self.screen.fill(self.background.tupel())
     for critter in self.population:
      rect = (critter.position.x,critter.position.y, self.creature_size, self.creature_size)
      pygame.draw.rect(self.screen,critter.skin_color.tupel(), rect)
     pygame.display.flip()   

  def place_velocity(self,critter):
    place = vector.Vector(self.width/2,self.height/2)
    return (place - critter.position) / 200
  
  def predator_velocity(self,critter):
    predator_place = vector.Vector(pygame.mouse.get_pos()[0],pygame.mouse.get_pos()[1])
    return ( predator_place - critter.position) / -250
    
  def live(self):
    for critter in self.population:
      center_velocity = critter.center_velocity()
      distance_velocity = critter.distance_velocity()
      similar_velocity = critter.similar_velocity()
      bounding_box_velocity = critter.bounding_box_velocity(self.width, self.height)
      place_velocity = self.place_velocity(critter)
      
      critter.velocity = critter.velocity + center_velocity + distance_velocity + similar_velocity + bounding_box_velocity + place_velocity
      critter.velocity = critter.velocity + self.predator_velocity(critter)
      critter.limit_velocity()
      critter.position = critter.position + critter.velocity


  def handle_event(self,event):
    if event.type == pygame.QUIT: sys.exit()
    elif event.type == pygame.VIDEORESIZE:
      self.screen=pygame.display.set_mode(event.dict['size'],pygame.HWSURFACE|pygame.DOUBLEBUF|pygame.RESIZABLE)
      pygame.display.flip()
      self.width, self.height = self.screen.get_width() , self.screen.get_height()
      self.screen.fill(self.background.tupel())
      pygame.display.flip()


  def start(self):
    while 1:  
      for event in pygame.event.get():
        self.handle_event(event)        
        
      self.draw()
      time.sleep(1/60)
      self.live()
  

Life().start()
        